/**
 * Worker.java
 *
 * This thread is used to demonstrate the operation of a semaphore.
 *
 * @author Greg Gagne, Peter Galvin, Avi Silberschatz
 * @version 1.0 - July 15, 1999
 * @version 1.1 - October 2, 2001 - Located the output message of
 * exiting the critical section to before the call to sem.V()
 *
 * Copyright 2000 by Greg Gagne, Peter Galvin, Avi Silberschatz
 * Applied Operating Systems Concepts - John Wiley and Sons, Inc.
 */

public class Worker extends Thread
{
   public Worker(Semaphore s, String n) {
      name = n;
      sem = s;
   }

   public void run() {
      while (true) {
         sem.P();

         System.out.println(name + " is entering critical section.");

         Runner.criticalSection();

         System.out.println(name + " has exited critical section.");
         
         sem.V();

         Runner.nonCriticalSection();
      }
   }

   private Semaphore sem;
  private String name;
}

